#include <stdio.h>
#include <stdlib.h>

typedef struct Tree
{
    int data;
    struct Tree *left, *right;
}Tree;

Tree* find(Tree *p, int data)
{
	if(p != NULL)
	{
		if(p->data == data)
			return p;
			
		Tree *pom;
		pom = find(p->left, data);
		if(pom)
			return pom;
		pom = find(p->right, data);
		return pom;
	}
	return NULL;
}




Tree * create(int data)
{
    Tree *pom;
    pom = (Tree*) malloc(sizeof(Tree));
    pom->data = data;
    pom->left = pom->right = NULL;

    return pom;
}

Tree *form()
{
    Tree* root, *pom;
    root = (Tree*) malloc(sizeof(Tree));
	scanf("%d", &(root->data));
	root->left = root->right = NULL;
    int parent, letfA, rightA;
    scanf("%d", &parent);

    while(parent != 0)
    {
        scanf("%d%d", &letfA, &rightA);
        pom = find(root, parent);
        if(letfA) pom->left = create(letfA);
        if(rightA) pom->right = create(rightA);
        scanf("%d", &parent);
    }

    return root;
}


Tree* searchLCA(Tree* root, Tree* x, Tree* y)
{
    if(!root) return NULL;

    if(root == x || root == y) return root;
 
    Tree* left = searchLCA(root->left, x, y);
    Tree* right = searchLCA(root->right, x, y);

    if(left && right) return root;

    if(left) return left;

    return right;
}
 
void findLCA(Tree* root, int firstData, int secondData)
{
    Tree *x = find(root, firstData);
    Tree *y = find(root, secondData);
    Tree* lca = NULL;
 
    if(x && y) lca = searchLCA(root, x, y);
 
    if(lca) 
        printf("NZP(%d,%d)=%d\n", firstData, secondData, lca->data);
    else 
        printf("NZP(%d,%d)=NULL\n", firstData, secondData);
}

void checkLCA(Tree *root)
{
    int n, firstData, secondData;
    scanf("%d", &n);
    for(int i = 0; i < n; i++)
    {
        scanf("%d%d", &firstData, &secondData);
        findLCA(root, firstData, secondData);
    }
}


int main()
{
    Tree *root;
    root = form();
    checkLCA(root);
    return 0;
}