#include <stdio.h>
#include <stdlib.h>

typedef struct Tree
{
    int data;
    struct Tree *left, *right;
}Tree;

Tree* find(Tree *p, int data)
{
	if(p )
	{
		if(p->data == data)
			return p;
			
		Tree *pom;
		pom = find(p->left, data);
		if(pom)
			return pom;
		pom = find(p->right, data);
		return pom;
	}
	return NULL;
}

Tree * create(int data)
{
    Tree *pom;
    pom = (Tree*) malloc(sizeof(Tree));
    pom->data = data;
    pom->left = pom->right = NULL;

    return pom;
}


Tree *form()
{
    Tree* root, *pom;
    root = (Tree*) malloc(sizeof(Tree));
	scanf("%d", &(root->data));
	root->left = root->right = NULL;
    int parent, letfA, rightA;
    scanf("%d", &parent);

    while(parent != 0)
    {
        scanf("%d%d", &letfA, &rightA);
        pom = find(root, parent);
        if(letfA) pom->left = create(letfA);
        if(rightA) pom->right = create(rightA);
        scanf("%d", &parent);
    }

    return root;
}


Tree* searchLCA(Tree* root, int x, int y, int *count)
{
    if(!root) return NULL;
    
    Tree* left = searchLCA(root->left, x, y, count);
    Tree* right = searchLCA(root->right, x, y, count);

    if(root->data == x || root->data == y)
    {
        (*count)++;
        return root;
    }

    if(left && right) return root;
    
    if(left) return left;
    
    return right;
}
 
void findLCA(Tree* root, int x, int y)
{
    int count = 0;
    Tree* lca = searchLCA(root, x, y, &count);
 
    if(count == 2 && lca || count == 1 && x==y) 
        printf("NZP(%d,%d)=%d\n",x, y, lca->data);
    else 
        printf("NZP(%d,%d)=NULL\n", x, y);

}

void checkLCA(Tree *root)
{
    int n, firstData, secondData;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d", &firstData, &secondData);
        findLCA(root, firstData, secondData);
    }
    
}


int main()
{
    Tree *root;
    root = form();
    checkLCA(root);
    return 0;
}